/**** Fichiers d'inclusion ****/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stddef.h>
#include <fcntl.h>
#include <errno.h>
#include <netdb.h>
#include <string.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>
#include <fcntl.h>
#include <netdb.h>

#include "lib_SMTP.h"
#include "../Communication/libcom.h"


void gestion_HELO(char *ligne,char *code,Client_t* client,FILE* dialogue)
{
	sscanf(ligne,"%4s %s",code,client->helo);
	fprintf(dialogue,"250 TristanJerome ZABETH11 (ID:%s) \r\n",client->helo);
}

void gestion_MAIL(char *ligne,char *code,Client_t* client,FILE* dialogue)
{
	sscanf(ligne,"%4s %s",code,client->mail);
	client->mail[strlen(client->mail)+1]='\0';
	fprintf(dialogue,"250 MAIL FROM: %s\r\n",client->mail);
}

void gestion_RCPT(char *ligne,char *code,Client_t* client,FILE* dialogue)
{
	sscanf(ligne,"%4s %s",code,client->rcpt);
	client->rcpt[strlen(client->rcpt)+1]='\0';
	fprintf(dialogue,"250 RCPT TO: %s\r\n",client->rcpt);
}

void gestion_QUIT(FILE* dialogue)
{
         fprintf(dialogue,"221 Bye\r\n");	 
}

void gestion_DATA(char *ligne, char *code,Client_t* client,FILE* dialogue)
{
   	client->taille_max=MAX_ALLOC;
	client->taille_body=0;
	client->body = malloc(client->taille_max);
	client->body[0]='\0';
	
	while(fgets(ligne,MAX_LIGNE,dialogue)!=NULL)
	{
		char verif[MAX_LIGNE];
		sscanf(ligne, "%s", verif);
		if (strcmp(verif,".")==0)
		{
			fprintf(dialogue,"250 DATA\r\n");
			printf("\n\r%s \n\r",client->body);
			break;
		}
		else if ((client->taille_max-client->taille_body)<=strlen(ligne))
		{		
			client->taille_max += MAX_ALLOC;
			client->body=realloc(client->body,client->taille_max);
		}
		strcat(client->body,ligne);
		client->taille_body += strlen(ligne);
	}
}




void gestionSmtp(void * arg)
{
	int s = *(int *) arg; 
	/* Obtient une structure de fichier */
	
	Client_t client;

	FILE *dialogue=fdopen(s,"a+");
	if(dialogue==NULL){ perror("gestionClient.fdopen"); exit(EXIT_FAILURE); }
	else {fprintf(dialogue,"220 TristanJerome ESMTP\n");}
	int flag_helo;


	char code[MAX_CODE];
	char ligne[MAX_LIGNE];



	while(fgets(ligne,MAX_LIGNE,dialogue)!=NULL)
	{
		sscanf(ligne,"%4s",code);
		if (strcmp(code,"HELO")==0)
		{	
			flag_helo=1;
			gestion_HELO(ligne,code,&client,dialogue);
		}

		else if(strcmp(code,"MAIL")==0)
		{
			if(flag_helo == 1)
			{
				gestion_MAIL(ligne,code,&client,dialogue);
			}
			else {fprintf(dialogue,"503 Les personnes polies s'annoncent\r\n");}
			
		}
	
		else if(strcmp(code,"RCPT")==0)
		{	
			if (flag_helo==1)
			{
				gestion_RCPT(ligne,code,&client,dialogue);
			}
			else {fprintf(dialogue,"503 Les personnes polies s'annoncent\r\n");}
		}

		else if(strcmp(code,"DATA")==0)
		{
			if (flag_helo==1)
			{
				fprintf(dialogue,"354 \n\r");
				gestion_DATA(ligne,code,&client,dialogue);
			}
			else {fprintf(dialogue,"503 Les personnes polies s'annoncent\r\n");}
		}

		else if (strcmp(code,"QUIT")==0) 
		{
			gestion_QUIT(dialogue);
			break;
		}
		
		else fprintf(dialogue, "502 commande non reconnue par le système, contactez le programmeur\r\n");
	}
	

	/* Termine la connexion */
	fclose(dialogue);
}

































